> For the complete documentation index, see [llms.txt](https://docs.bluefletch.com/bluefletch-enterprise/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/schedule-actions.md).

# Schedule Actions

A Launcher automation feature that schedules tasks to run automatically at a designated time, date, or recurring interval.

## Overview

Use Schedule Actions to automate tasks within your launcher. You can set specific apps to open, adjust volume, reboot the device, or run custom intents automatically at a designated time, date, or recurring interval.

Schedule Actions is disabled by default. It is enabled by adding a schedules object to the Launcher configuration, which can contain multiple custom-named schedule objects (e.g., “schedule1”, "deviceReboot", "AdjustVolume", etc.)

## User Guide

1. Add a `schedules` object to the Launcher configuration.
2. Define a `schedule` object to set the timing and registration criteria.
3. Define an `execution` object to specify the actions and runtime conditions.

## Configuration

### `schedules`&#x20;

To enable Schedule Actions, add a `schedules` block to the Launcher's JSON configuration file.

The base-level key-value pairs of the scheduled configuration include:

| Field     | Description                                                                                                                                                                                                            |
| --------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| *\<name>* | <p><strong>String.</strong> Any descriptive name to easily identify the action. <br><br>For instance  <code>"deviceReboot"</code> and <code>"AdjustVolume"</code> in the <a href="#full-example">Full Example</a>.</p> |
| schedule  | **Object.** Collection of parameters to define the timing of the actions.                                                                                                                                              |
| execution | **Object.** Collection of parameters to define the content of the actions.                                                                                                                                             |

In the launcher.json file, these are arranged:

```json
 "schedules": {
   "deviceReboot": { // referenced as <name> in the table above
     "schedule": {},
     "execution": {}
   }
 }
```

### Configuring a `schedule` Object

The `schedule` object defines the frequency of the task and the criteria required to register the schedule on the device. The `schedule` object consists of the following parameters:

<table data-search="false"><thead><tr><th>Field</th><th>Description</th></tr></thead><tbody><tr><td>hour</td><td><strong>String.</strong> Set the hour (use 24-hour time, e.g. <code>"13"</code> for 1 pm) that the scheduled action should occur.</td></tr><tr><td>minute</td><td><strong>String.</strong> Set the minute that the scheduled action should occur.</td></tr><tr><td>dayOfWeek</td><td><strong>String.</strong> Set the numeric value of the day of the week (starting with <code>"1"</code> for Monday to <code>"7"</code> for Sunday) that the scheduled action should occur.</td></tr><tr><td>day</td><td><strong>String.</strong> Set the day of the month (<code>"1"</code> through <code>"31"</code>) that the scheduled action should occur.</td></tr><tr><td>month</td><td><strong>String.</strong> Set the numeric value of the month (e.g. <code>"4"</code> for April) that the scheduled action should occur.</td></tr><tr><td>year</td><td><strong>String.</strong> Set the year that the scheduled action should occur.</td></tr><tr><td>frequency</td><td><strong>String.</strong> The recurrence rule: <code>"onetime"</code>, <code>"minutely"</code>, <code>"hourly"</code>,  <code>"daily"</code>, <code>"weekly"</code>, <code>"monthly"</code>.</td></tr><tr><td>criteriaToSchedule</td><td><strong>Object.</strong> Conditions evaluated before the schedule is registered. If these fail, the timer is never set.<br><br>For details, see the <a href="https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/configurable-layouts/criteria.md">Criteria</a> documentation.</td></tr></tbody></table>

### Configuring an `execution` Object

The execution object defines what happens when the scheduled time arrives. The execution object consists of the following parameters:

| Field             | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| ----------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| customIntent      | <p><strong>Object.</strong> The payload to execute. Contains an <code>action</code> string, a <code>typeIntent</code> (e.g. <code>"p"</code> for platform actions), and other optional parameters.</p><p></p><p>For the full list of supported <code>action</code> strings, refer to the <a href="https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/custom-intents/platform-actions">Custom Intents Platform Actions</a>. For the full list of supported parameters, see  <a href="https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/custom-intents/technical-guide.md#key-value-pairs">Key-Value Pairs</a>.</p> |
| retryMissedAlarm  | <p><strong>Boolean.</strong> If true, the launcher will re-attempt to fire a missed action due to failed execution.<br><br>Default value is <code>false</code>. </p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| retryAfterMinutes | <p><strong>Integer.</strong> The delay (in minutes) before attempting a retry if the initial execution criteria failed or the alarm was missed.<br><br>Default value is <code>5</code>.</p>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| criteria          | <p><strong>Object.</strong> Real-time conditions evaluated at the exact moment the schedule fires. If false, the action is skipped.<br><br>For details, see the <a href="https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/configurable-layouts/criteria.md">Criteria</a> documentation.</p>                                                                                                                                                                                                                                                                                                                                                        |

### Full Example

An example of a full configuration for two Schedule Actions, `"deviceReboot"` and `"AdjustVolume"`:

```json
 "schedules": {
   "deviceReboot": {
     "schedule": {
       "hour": "13",
       "minute": "30",
       "dayOfWeek": "",
       "day": "",
       "month": "",
       "year": "",
       "frequency": "daily",
       "criteriaToSchedule": {
         "criteria_OR": [
           {
             "field": "_${session.userId}",
             "pattern": "^_$"
           }
         ]
       }
     },
     "execution": {
       "criteria": {
         "criteria_OR": [
           {
             "field": "${launcherState.isConnectedToNetwork}",
             "pattern": "true"
           }
         ]
       },
       "customIntent": {
         "action": "REBOOT",
         "typeIntent": "p",
         "extras": {
           "notification": 0,
           "alarm": 0,
           "others": 0
         }
       },
       "retryMissedAlarm": true,
       "retryAfterMinutes": 5
     }
   },
   "AdjustVolume": {
     "schedule": {
       "hour": "",
       "minute": "30",
       "dayOfWeek": "",
       "day": "",
       "month": "",
       "year": "",
       "frequency": "minutely",
       "criteriaToSchedule": {
         "criteria_OR": [
           {
             "field": "_${session.userId}",
             "pattern": "^_$"
           }
         ]
       }
     },
     "execution": {
       "criteria": {
         "criteria_OR": [
           {
             "field": "${launcherState.isConnectedToNetwork}",
             "pattern": "true"
           }
         ]
       },
       "customIntent": {
         "action": "ADJUST_AUDIO",
         "typeIntent": "p",
         "extras": {
           "notification": 100,
           "alarm": 100,
           "others": 100
         }
       },
       "retryMissedAlarm": true,
       "retryAfterMinutes": 5
     }
   }
 }
```

Schedule Actions was introduced in Launcher 4.4.32.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/schedule-actions.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
